SystemOrganization addCategory: #Abbreviations!
(PackageInfo named: 'Abbreviations') postscript: '"To assign abbreviation expand action to hot key (Alt+space) do:
   SmalltalkEditor cmdActions at: 32 + 1 put: #expandWord:.

To manage current abbreviations set do: 
    SmalltalkEditor abbreviationsDict inspect.
"'!

!TextEditor class methodsFor: '*Abbreviations' stamp: 'abbat 8/30/2010 12:32'!
abbreviationsDict
	AbbreviationsDict isNil
		ifTrue: [AbbreviationsDict := Dictionary new.
			AbbreviationsDict at: 'ps' put: 'printString'].
	^ AbbreviationsDict! !

!TextEditor methodsFor: '*Abbreviations' stamp: 'abbat 8/30/2010 12:38'!
expandWord: characterStream 
	"Replace abbreviation word on left of cursor with appropriate string."
	| ch word dict newWord startIndex |
	startIndex := self pointIndex.
	[startIndex := startIndex - 1.
	startIndex > 0
		and: [ch := self string at: startIndex.
			ch isAlphaNumeric]] whileTrue.
	word := self string copyFrom: startIndex + 1 to: self pointIndex - 1.
	word isEmpty
		ifTrue: [^ true].
	dict := self class abbreviationsDict.
	newWord := dict
				at: word
				ifAbsent: [newWord := FillInTheBlank request: 'Input abbreviation for ''' , word , ''':' initialAnswer: ''.
					newWord isEmpty
						ifFalse: [dict at: word put: newWord].
					newWord].
	newWord
		ifEmpty: [^ true].
	paragraph
		replaceFrom: startIndex + 1
		to: self pointIndex - 1
		with: newWord.
	self selectAt: self pointIndex + (newWord size - word size).
	^ true! !
